/*
btdbsz.c Version 0.1.0  Btree counts records in database
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* returns total blocks and total count */
/* in database */

#include <bthash.h>

void btdbsz(bthdr,blocks,count)
btreefmt *bthdr;
int *blocks;
int *count;
   {
   int eofsw,rdlen;
   blkfmt *blk;
   off_t loc;
   unsigned char buf[65536 + 16];
   bthdr->reason = 0;
   loc = lseek(bthdr->hndl,ROOT,SEEK_SET);
   if (loc != ROOT)
      {
      perror("btdbsz: lseek err");
      bthdr->reason = SYS_ERR + errno;
      return;
      } /* if lseek err */
   *blocks = *count = eofsw = 0;
   blk = (blkfmt *) buf;
   while (!eofsw)
      {
      rdlen = read(bthdr->hndl,buf,bthdr->blksz);
      if (rdlen < 0)
	 {
         perror("btdbsz: read error");
         bthdr->reason = SYS_ERR + errno;
         return;
	 } /* read err */
      if (rdlen == bthdr->blksz)
	 {
         *count += blk->count;
         (*blocks)++;
	 } /* if good read */
      else if (!rdlen)
	 {
	 eofsw = 1;
         break;
	 } /* eof */
      else
	 {
         fprintf(stderr,"btdbsz: read error\n");
         fprintf(stderr,"bthdr->blksz %d "
	    "rdlen %d\n",
	    bthdr->blksz, rdlen);
         bthdr->reason = BTREE_ERR + 1201;
         return;
	 } /* read err */
      } /* for each block in db */
   } /* btdbsz */
